stages:
  - codequality
  - tests
  - publish

include:
  remote: 'https://gitlab.com/gitlab-org/gitlab/-/raw/v14.3.0-ee/lib/gitlab/ci/templates/Composer.gitlab-ci.yml'

publish:
  stage: publish

.test-shared: &test-shared
  # Select what we should cache between builds
  cache:
    key: "$CI_JOB_NAME"
    paths:
      - vendor/
  stage: tests
  before_script:
    - if [[ ! -z $COMPOSER_AUTH_JSON ]] ; then mkdir -p /root/.composer ; echo $COMPOSER_AUTH_JSON > ~/.composer/auth.json ; fi
    - composer install --prefer-dist
  artifacts:
    paths:
      - tests/_output
    expire_in: 1 week
    when: always
    reports:
      junit: _output/report.xml

phpcs:
  stage: codequality
  image: registry.gitlab.com/traffic_control/docker-containers/php:tc-phpcs
  script:
    - phpcs --extensions=php ./src

test:7.4:
  <<: *test-shared
  image: registry.gitlab.com/traffic_control/docker-containers/php:7.4-cli-pcov
  script:
    - php -dpcov.exclude="~vendor~" vendor/bin/codecept run --coverage --coverage-html --xml --html --no-colors

test:8.0:
  <<: *test-shared
  image: registry.gitlab.com/traffic_control/docker-containers/php:8.0-cli-pcov
  script:
    - php -dpcov.exclude="~vendor~" vendor/bin/codecept run --coverage --coverage-html --xml --html --no-colors

test:8.1:
  <<: *test-shared
  image: registry.gitlab.com/traffic_control/docker-containers/php:8.1-cli-pcov
  script:
    - php -dpcov.exclude="~vendor~" vendor/bin/codecept run --coverage --coverage-html --xml --html --no-colors

test:8.2:
  <<: *test-shared
  image: registry.gitlab.com/traffic_control/docker-containers/php:8.2-cli-pcov
  script:
    - php -dpcov.exclude="~vendor~" vendor/bin/codecept run --coverage --coverage-html --xml --html --no-colors
